--
-- autoRogue
-- Automatically cast various rogue spells
--
-- What it does:
-- cast Eviscerate (if possible), before sinister strike                            
--
-- you need Eviscerate,Backstab and Sinister strike on any one of your action bars
-- (only once). they don't have to be visible for this to work.  
--
-- Copyright (c) 2005 EvilTeddyBear
--
autoRogue = {}
autoRogue.name 				= "AutoRogue"
autoRogue.version 			= "1.12.1126"
autoRogue.desc 				= "Automates most Rogue functions.  Intended for Combat rogues."
autoRogue.percent = "%"
autoRogue.debugA            = false
autoRogue.debug 			= false
autoRogue.tSinisterStrike   = {nil, 0}
autoRogue.tBackStab	        = {nil, 0}
autoRogue.tFeint 	        = {nil, 0}
autoRogue.tColdBlood	    = {nil, 0}
autoRogue.tRiposte		    = {nil, 0}
autoRogue.tGStrike		    = {nil, 0}
autoRogue.tVanish      		= {nil, 0}
autoRogue.tHemo      		= {nil, 0}
autoRogue.tBFlurry     		= {nil, 0}
autoRogue.tARush     		= {nil, 0}
autoRogue.tEvas     		= {nil, 0}
autoRogue.tTea     			= {nil, 0}
autoRogue.tSliceDice	    = {nil, 5}
autoRogue.tKidneyShot	    = {nil, 5}
autoRogue.tExpose		    = {nil, 5}
autoRogue.tRupture		    = {nil, 5}
autoRogue.tEviscerate       = {nil, 5}
autoRogue.tAmbush       	= {nil, 0}
autoRogue.tKick       		= {nil, 0}
autoRogue.tGouge       		= {nil, 0}
autoRogue.enabled = true
autoRogue.AutoRogueButton = false;
autoRogue.hp1pt = 1000
autoRogue.hp2pt = 1500
autoRogue.hp3pt = 2000
autoRogue.hp4pt = 2500
autoRogue.hp5pt = 3000
autoRogue.SnDpt = 2

autoRogue.tFinisher     	= {nil, 5}
autoRogue.tSnDDump	     	= {nil, 5}
autoRogue.tSD		    	= {nil, 0}
autoRogue.tSS   			= {nil, 0}
autoRogue.tBS	        	= {nil, 0}
autoRogue.tHE      			= {nil, 0}
autoRogue.tFt 	        	= {nil, 0}
autoRogue.tRi		    	= {nil, 0}
autoRogue.tBF		    	= {nil, 0}
autoRogue.tAR		    	= {nil, 0}
autoRogue.tGS		    	= {nil, 0}
autoRogue.tKK		    	= {nil, 0}
autoRogue.tGG		    	= {nil, 0}
autoRogue.tKILL		    	= {nil, 6}

autoRogue.trinket1 = nil
autoRogue.trinket2 = nil

local function autoRogue_melee() return CheckInteractDistance('target',2) end
local function autoRogue_ranged() return not autoRogue_melee() end

-- Value of Damage per energy tick
local autoRogue_DPT = 0;

-- Value of last per energy tick
local autoRogue_LastDPT = 0;

-- Value of current per energy tick
local autoRogue_CurrDPT = 0;

-- Value of last energy increase (usually 20)
local autoRogue_LastEnergy = 20;

-- Value of energy ticks til 35 (for Eviscerate)
local autoRogue_EnergyTick = 0;

-- stored energy from the last time the energy changed
local autoRogue_CurrEnergy = 100;

-- Used to check whether player is entering game for the first time or not
local autoRogue_EnteredGame = false;

-- Used for cooldown checking
local autoRogue_Timer = {};

autoRogue.tRogueSS = { autoRogue.tFinisher, autoRogue.tSS, autoRogue.tRi, autoRogue.tKILL }
autoRogue.tRogueHM = { autoRogue.tFinisher, autoRogue.tHE, autoRogue.tRi, autoRogue.tKILL }
autoRogue.tRogueBS = { autoRogue.tFinisher, autoRogue.tBS, autoRogue.tRi, autoRogue.tKILL }
autoRogue.tRogueBF = { autoRogue.tFt, autoRogue.tBF, autoRogue.tAR, autoRogue.tGS, autoRogue.tSD, autoRogue.tKK, autoRogue.tGG }

autoRogue.canKick 			= false
autoRogue.DumpReady			= false

autoRogue.xOffset           = 10;
autoRogue.yOffset           = 39

autoRogue.fSinisterStrike   = nil
autoRogue.fBackStab	        = nil
autoRogue.fFeint 	        = nil
autoRogue.fSliceDice	    = nil
autoRogue.fColdBlood	    = nil
autoRogue.fKidneyShot	    = nil
autoRogue.fEviscerate       = nil
autoRogue.fRupture 			= nil
autoRogue.fRiposte 			= nil
autoRogue.fGStrike          = nil
autoRogue.fExpose 			= nil
autoRogue.fKick 			= nil
autoRogue.fAmbush 			= nil
autoRogue.fVanish 			= nil
autoRogue.fHemo 			= nil
autoRogue.fBFlurry			= nil
autoRogue.fARush			= nil
autoRogue.fEvas				= nil
autoRogue.fGouge			= nil
local ARTargetData;
ARTargetHP                  = 10000000
autoRogue.talentCache = {}
autoRogue.eviscDamage = {
   { (7+11)/2, (13+17)/2, (19+23)/2, (25+29)/2, (31+35)/2 },
   { (16+24)/2, (29+37)/2, (42+50)/2, (55+63)/2, (68+76)/2 },
   { (29+43)/2, (52+66)/2, (75+89)/2, (98+112)/2, (121+135)/2 },
   { (47+67)/2, (84+104)/2, (121+141)/2, (158+178)/2, (195+215)/2 },
   { (69+99)/2, (123+153)/2, (177+207)/2, (231+261)/2, (285+315)/2 },
   { (104+148)/2, (186+230)/2, (268+312)/2, (350+394)/2, (432+476)/2 },
   { (158+226)/2, (282+350)/2, (406+474)/2, (530+598)/2, (654+722)/2 },
   { (216+312)/2, (384+480)/2, (552+648)/2, (720+816)/2, (888+984)/2 },
   { (224+332)/2, (394+502)/2, (564+672)/2, (734+842)/2, (904+1012)/2 },
}

-- converts string.format to a string.find pattern: "%s hits %s for %d." to "(.+) hits (.+) for (%d+)"
local function autoRogue_Format2Find(pattern)
	local i,k,field,idx;
	pattern = string.gsub(pattern,"%.", "%%%.");
	pattern = string.gsub(pattern,"%(", "%%%(");
	pattern = string.gsub(pattern,"%)", "%%%)");
	-- Convert placeholders to regular expression patterns.
	pattern = string.gsub(pattern,"%%s","(.+)"); -- %s to (.+)
	pattern = string.gsub(pattern,"%%d","(%%d+)"); -- %d to (%d+)

	if string.find(pattern,"%$") then
		pattern = string.gsub(pattern,"%%%d%$s","(.+)");
		pattern = string.gsub(pattern,"%%%d%$d","(%%d+)");
	end
	return pattern
end

function autoRogue.OnLoad()
   local junk, englishClass = UnitClass("player")
   if (englishClass ~= "ROGUE") then
		autoRogue.p("You are no rogue, quitting...")	 
	  return        
   end

      
   	--Get Player Name and Current Realm so Options can be saved per character
	ARPlayerRealm = GetCVar("realmName")
	ARPlayerName = UnitName("player")
 	this:RegisterEvent("VARIABLES_LOADED");
 	this:RegisterEvent("PLAYER_ENTERING_WORLD");
 	this:RegisterEvent("PLAYER_LEAVING_WORLD");
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("UNIT_COMBAT");
	this:RegisterEvent("UNIT_ENERGY");
   	this:RegisterEvent("PLAYER_REGEN_ENABLED");
   	this:RegisterEvent("UNIT_COMBO_POINTS");
   	this:RegisterEvent("ACTIONBAR_SLOT_CHANGED");
   	this:RegisterEvent("UNIT_INVENTORY_CHANGED");
   	this:RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE");
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_CREATURE_BUFFS");
	this:RegisterEvent("CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF");
	this:RegisterEvent("CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE");
	this:RegisterEvent("CHAT_MSG_SPELL_HOSTILEPLAYER_BUFF");
	this:RegisterEvent("CHAT_MSG_MONSTER_EMOTE");
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_SELF_DAMAGE");
	this:RegisterEvent("CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_BUFFS");
	this:RegisterEvent("CHAT_MSG_SPELL_AURA_GONE_OTHER");
    this:RegisterEvent("CHAT_MSG_COMBAT_SELF_HITS");

 	
	autoRogue_Orig_UseAction = UseAction
	UseAction = autoRogue_New_UseAction

   	--MyAddons Support for options frame
	UIPanelWindows["AutoRogueOptionsFrame"] = {area = "center", pushable = 0};
	AutoRogue_IconFrame:Show()
  autoRogue.ScanSpellsAndBars()
  autoRogue.p("autoRogue v"..autoRogue.version.." loaded.")
end

function autoRogue.EnergyTick()
 if not(autoRogue.fEviscerate == nil) then
	-- Player's current stats
	local curr = UnitMana("player");
	local cooldownstart, cooldown = GetSpellCooldown(autoRogue.fEviscerate, "spell");

	if autoRogue_EnergyTick > 0 then
	    autoRogue.da(autoRogue_EnergyTick.."s")
	end

	if ( not cooldown) then
		cooldown = 0;
	end

	if ( cooldown > 1) then
		-- Spell is in cooldown
		eviscisready = false;
		evisccooldown = ceil(( cooldownstart + cooldown ) - GetTime());
	else
		-- Only if there is no cooldown on skill (or cooldown is 1 second or less)
		-- set the skill to have no cooldown
		evisccooldown = 0;
		autoRogue_EnergyTick = 0;

		-- if energy decreases (skill use or drain) then ignore except to reset last know energy to current
		-- if energy increases then reset the tick rate to the difference between last know energy and current
		if ( autoRogue_CurrEnergy and curr and curr > autoRogue_CurrEnergy  ) then
			autoRogue_LastEnergy = curr - autoRogue_CurrEnergy;
			if ( not autoRogue_LastEnergy) then
				autoRogue_LastEnergy = 1;
			end
		end

		-- Set last known current energy to current energy
		autoRogue_CurrEnergy = curr;

		local y = 0;
		-- energy is energy required to use skill
		local ARenergy = 35


		-- If player has enough energy for this skill already
		if ( ARenergy <= autoRogue_CurrEnergy) then
				-- Set the ready value to true (used when clicking button, click only works if ready is true)
   				eviscisready = true;
		else
			-- otherwise the player does not have enough energy

			-- Find out how much energy is required (require energy for skill take away current energy left)
			ARenergy = ARenergy - autoRogue_CurrEnergy;

			-- loop taking energy gained per tick from energy still needed and count how many times the tick would need to take place
			local x = 0;
			while ARenergy > 0 do
				-- take tick rate from energy until less than zero and count how many times it will take
				ARenergy = ARenergy - autoRogue_LastEnergy;
				x = x + 1;
			end
            autoRogue_EnergyTick = x

   			eviscisready = false;
		end
	end
	if ARlastHP then
		if not(ARTargetHP == 10000000) then
			if (ARTargetHP < ARlastHP) then
			    if autoRogue_DPT < 0 then
				autoRogue_DPT = (autoRogue_DPT + (ARlastHP - ARTargetHP)) / 2
				else
				autoRogue_DPT = ARlastHP - ARTargetHP
				end
			end
		end
	end
			ARlastHP = ARTargetHP
	        --autoRogue.p(string.format("%d",autoRogue_DPT).. " Damage Per Tick")
	        --autoRogue.p(autoRogue_DPT.. " Damage Per Tick")
end
end

function autoRogue.FindTalentPoints(icon)
   -- Okay, there is no event that gets fired when talents have changed, so
   -- just for fun, we cache talent point lookups for 1 minute.  Not sure
   -- how much this really helps performance, but hey.

   local cacheInfo = autoRogue.talentCache[icon]
   if (cacheInfo) then
      local time = cacheInfo[1]
      local rank = cacheInfo[2]
      if (time and time > (GetTime() - 120)) then
         return rank
      end
   end

   rank = 0
   for i = 1, GetNumTalentTabs() do
      for j = 1, GetNumTalents(i) do
         local name, thisIcon, _, _, rank, max = GetTalentInfo(i, j)
         if (thisIcon and string.find(thisIcon, icon)) then
            autoRogue.talentCache[icon] = {GetTime(), rank}
            return rank
         end
      end
   end
   
   lr.talentCache[icon] = {GetTime(), 0}
   return 0
end

    -- Takes in a string of the form 'Rank N' and extracts the 'N'.  If the string isn't
    -- in that form, returns nil.
function autoRogue.ExtractRank(str)
        if(not str) then return 0; end
		
		local ret = string.gfind(str, autoRogue_RANK)();
		if(ret) then
			return tonumber(ret);
		else
			return 0;
		end
end;
function autoRogue.IsEviscKillShot()
             local AR_cp = GetComboPoints()
             if (AR_cp == 0) then
                return false
             end
             
             local ARhp = ARTargetHP

             -- find eviscerate rank
             -- lookup damage AR_cp using damage table
             local spellName, spellRank = GetSpellName(autoRogue.fEviscerate, SpellBookFrame.bookType)
             local rank = autoRogue.ExtractRank(spellRank)
             autoRogue.da(spellName.." rank "..rank)
             if (rank == 0) then
                return false
             end
			 local eviscDamage = autoRogue.eviscDamage[rank][AR_cp]
			----begin 1.12 ap scale changes----
		  	 local ARbase, ARposBuff, ARnegBuff = UnitAttackPower("player");
			 local AReffective = ARbase + ARposBuff + ARnegBuff;

			 	if AReffective >= 600 and AReffective <= 799 then 
					 eviscDamage = eviscDamage + (0.15*(AReffective))
				elseif AReffective >= 800 and AReffective <= 1499 then 
					 eviscDamage = eviscDamage + (0.25*(AReffective))				
				end
			----end 1.12 ap scale changes----
			
			 --local eviscDamage = (eviscDamage + posBuff + negBuff) * percentmod
             if (not eviscDamage) then
                autoRogue.da("strange, damage lookup failed")
                return false
             end
             --origEviscDamage = eviscDamage
             -- adjust for Improved Eviscerate, if invested
             local ARieAdjust = { 1.05, 1.1, 1.15 }
             local ARtpts = autoRogue.FindTalentPoints("Ability_Rogue_Eviscerate")
             if (ARtpts > 0) then
                eviscDamage = eviscDamage * ARieAdjust[ARtpts]
             end
             -- adjust for Aggression, if invested
             local ARaggrAdjust = { 1.02, 1.04, 1.06 }
             local ARtpts = autoRogue.FindTalentPoints("Ability_Racial_Avatar")
             if (ARtpts > 0) then
                eviscDamage = eviscDamage * ARaggrAdjust[ARtpts]
             end
              -- adjust for Cold Blood, if we're asked to, or if active
             if autoRogue_CurrActiveBuff("Cold Blood", "player") then
                -- Cold Blood guarantees a crit (if it hits)
                eviscDamage = eviscDamage * 2
             end
             
			 if autoRogue_EnergyTick > 0 then
			    if autoRogue_EnergyTick == 1 then
			     	autoRogue_DPT = autoRogue_DPT * 2
				elseif autoRogue_EnergyTick == 2 then
				    autoRogue_DPT = autoRogue_DPT * 3
				end
                eviscDamage = eviscDamage + autoRogue_DPT
			 end
             local EvisisUsable, EvisnotEnoughMana = IsUsableAction(autoRogue.tEviscerate[1]);

             if ARData[ARPlayerRealm][ARPlayerName].Auto_Evis_Low == true and (ARhp <= eviscDamage) and not(EvisnotEnoughMana == 1) then
                if (AR_cp < 5) then
                   --killshotmsg = "Early eviscerate! Kill shot! at "..eviscDamage.."hp"
                   --killshotmsg = "Early eviscerate! Kill shot! at "..eviscDamage.."hp and DPT of "..autoRogue_DPT
                end
                autoRogue.da(ARhp.." "..eviscDamage)
                return true
             else
                return false
             end
end
function autoRogue.CheckCastfirst()
				local ARmyunithp = UnitHealth("target")
				local AR_cp = GetComboPoints()
				local myautoRogueAR_cp = 5
				local AR_targetClass = nil
				local autoRogue_meleeTarget = false
				if 	not(autoRogue.tEviscerate[1])== nil then
					local EvisisUsable, EvisnotEnoughMana = IsUsableAction(autoRogue.tEviscerate[1]);
				else
					EvisnotEnoughMana = nil
				end

				local tempclass, tClass = UnitClass("target")
   				if (tClass == "ROGUE") then
	    			autoRogue_meleeTarget = true
				elseif (tClass == "WARRIOR") then
	    			autoRogue_meleeTarget = true
				elseif (tClass == "PALADIN") then
	    			autoRogue_meleeTarget = true
				elseif (tClass == "DRUID") then
	    			autoRogue_meleeTarget = true
				else
	    			autoRogue_meleeTarget = false
				end
						if UnitName("target") == nil or UnitHealth("target") == 0 and (msg == false) then
  							ARTargetHP = 10000000
  							autoRogue.tEviscerate[2] = 5
            				if (not PlayerFrame.inCombat) then
								if (UnitName("target")~=nil) then
									TargetNearestEnemy();
									CastSpellByName ("Attack");
								else

									CastSpellByName ("Attack");
								end
							end;
						end
	if autoRogue_melee() then
		AR_affectingCombat = UnitAffectingCombat("player");
		if AR_affectingCombat == 1 then 
			if ( UnitIsUnit("targettarget", "player") ) and ARData[ARPlayerRealm][ARPlayerName].Auto_Vanish == true then
				if (UnitLevel("target") > 60) or (UnitLevel("target") == -1) or ((UnitIsPlayer("target")) and (autoRogue_meleeTarget == true)) then
					if ARData[ARPlayerRealm][ARPlayerName].Auto_Evasion == true then
						autoRogue.CastaltVA()
					else
						autoRogue.da("Attempting Vanish because "..UnitName("target").." has you Targeted!")
						autoRogue.CastVA()
					end
				end
			end

			if ( UnitIsUnit("targettarget", "player") ) and ARData[ARPlayerRealm][ARPlayerName].Auto_Evasion == true then
				if (UnitLevel("target") > 60) or (UnitClassification("target") == "elite") and (UnitLevel("target") > 55)or (UnitClassification("target") == "rareelite") and (UnitLevel("target") > 57) or (UnitLevel("target") == -1) or ((UnitIsPlayer("target")) and (autoRogue_meleeTarget == true)) then
						autoRogue.da("Attempting Evasion because "..UnitName("target").." has you Targeted!")
					    autoRogue.CastEVA()
				end
			end
			if ARData[ARPlayerRealm][ARPlayerName].Auto_Tea == true then
				autoRogue.CastTEA()
			end
            local ARmyperHP = UnitHealth("player") / UnitHealthMax("player") *100
			if (ARmyunithp >=50 and AR_cp == 5) and ARData[ARPlayerRealm][ARPlayerName].Auto_Kidney == true and not(autoRogue.IsEviscKillShot() == true) and not(autoRogue.fKidneyShot == nil) or (ARmyperHP <=50 and AR_cp == 5) and ARData[ARPlayerRealm][ARPlayerName].Auto_Kidney == true and not(autoRogue.IsEviscKillShot() == true) and not(autoRogue.fKidneyShot == nil) then
				autoRogue.CastKS()
			end
		end
	end--
	if autoRogue_melee() then
		AR_affectingCombat = UnitAffectingCombat("player");
		if AR_affectingCombat == 1 then		
        		if (ARData[ARPlayerRealm][ARPlayerName].Auto_SliceDice == true and AR_cp == autoRogue.SnDpt) and (not(autoRogue.IsEviscKillShot() == true) and not(autoRogue.fSliceDice == nil)) then
				  local autoRogue_Counter = 1
				  local autoRogue_Buff = GetSpellTexture(autoRogue.fSliceDice, 0)
					while (UnitBuff("player", autoRogue_Counter)) do
 					   	if (UnitBuff("player", autoRogue_Counter) == autoRogue_Buff) then
							if (ARData[ARPlayerRealm][ARPlayerName].Auto_SliceDiceDump == true) and AR_cp == autoRogue.SnDpt then
								autoRogue.CastSnDDump()
	      						autoRogue.tSD[1] = autoRogue.tSnDDump[1]
	      						autoRogue.tSD[2] = autoRogue.tSnDDump[2]
							else
	      						autoRogue.tSD[1] = nil
	      						autoRogue.tSD[2] = nil
							end
							return
						end
					    autoRogue_Counter = autoRogue_Counter + 1
					end
						autoRogue.tSD[1] = autoRogue.tSliceDice[1]
      					autoRogue.tSD[2] = autoRogue.SnDpt
				else
      				autoRogue.tSD[1] = nil
      				autoRogue.tSD[2] = nil
				end
 				if ARData[ARPlayerRealm][ARPlayerName].Auto_Trinket1 == true then
                 	autoRogue.UseTrinket1()
				end
				if ARData[ARPlayerRealm][ARPlayerName].Auto_Trinket2 == true then
                 	autoRogue.UseTrinket2()
				end
		end
	end
		autoRogue.Cast5ptFinisher()
			if autoRogue.IsEviscKillShot() == true and EvisnotEnoughMana == nil then
				autoRogue.tKILL[1] = autoRogue.tEviscerate[1]
				autoRogue.tKILL[2] = AR_cp
			else
			    autoRogue.tKILL[1] = nil
			    autoRogue.tKILL[2] = 6
			end
end
function autoRogue.Cast5ptFinisher()
	local AR_cp = GetComboPoints()
	if ARData[ARPlayerRealm][ARPlayerName].Auto_Evis_High == true then
	autoRogue.Finisher = ARData[ARPlayerRealm][ARPlayerName].Finisher
		if autoRogue.Finisher == "Slice and Dice" then
			autoRogue.tFinisher[1] = autoRogue.tSliceDice[1]
		elseif autoRogue.Finisher == "Rupture" then
			autoRogue.tFinisher[1] = autoRogue.tRupture[1]
		elseif autoRogue.Finisher == "Expose Armor" then
			autoRogue.tFinisher[1] = autoRogue.tExpose[1]
		elseif autoRogue.Finisher == "Kidney Shot" then
			autoRogue.tFinisher[1] = autoRogue.tKidneyShot[1]
		elseif autoRogue.Finisher == "Eviscerate" then
			autoRogue.tFinisher[1] = autoRogue.tEviscerate[1]
		end
        autoRogue.tFinisher[2] = 5
	else
		autoRogue.da("finisher not ready")
        autoRogue.tFinisher[1] = nil
	end
end
function autoRogue.CastSnDDump()
	local AR_cp = GetComboPoints()
	if ARData[ARPlayerRealm][ARPlayerName].Auto_SliceDice == true then
	autoRogue.SnDDump = ARData[ARPlayerRealm][ARPlayerName].SnDDump
		if autoRogue.SnDDump == "Rupture" and autoRogue.CheckRU() == false then
			autoRogue.tSnDDump[1] = autoRogue.tRupture[1]
		elseif autoRogue.SnDDump == "Expose Armor" and autoRogue.CheckEX() == false then
			autoRogue.tSnDDump[1] = autoRogue.tExpose[1]
		elseif autoRogue.SnDDump == "Kidney Shot" and not(autoRogue_isTargetStunned() == true) then
			autoRogue.tSnDDump[1] = autoRogue.tKidneyShot[1]
		elseif autoRogue.SnDDump == "Eviscerate" then
			autoRogue.tSnDDump[1] = autoRogue.tEviscerate[1]
		else
		    autoRogue.tSnDDump[1] = nil
		end
		autoRogue.tSnDDump[2] = autoRogue.SnDpt
	else
        autoRogue.tSnDDump[1] = nil
        autoRogue.tSnDDump[2] = nil
	end
end
function autoRogue.CheckCastCDbuffs()
				local ARmyunithp = UnitHealth("target")
				local AR_cp = GetComboPoints()
				local myautoRogueAR_cp = 5
				local AR_targetClass = nil
		if ARData[ARPlayerRealm][ARPlayerName].Auto_ARush == true and ARmyunithp <= 95 and ( UnitAffectingCombat("player") == 1 ) and  not(autoRogue.tARush[1] == nil) and (not(UnitName("target") == nil) or not(UnitHealth("target") == 0)) then
            autoRogue.tAR[1] = autoRogue.tARush[1]
		else
			autoRogue.tAR[1] = nil
		end
        if ARData[ARPlayerRealm][ARPlayerName].Auto_BFlurry == true and ARmyunithp <= 95 and ( UnitAffectingCombat("player") == 1 ) and not(autoRogue.tBFlurry[1] == nil) and (not(UnitName("target") == nil) or not(UnitHealth("target") == 0)) then
            autoRogue.tBF[1] = autoRogue.tBFlurry[1]
		else
			autoRogue.tBF[1] = nil
		end
		if ARData[ARPlayerRealm][ARPlayerName].Auto_GStrike == true and ARmyunithp <= 95 and ( UnitAffectingCombat("player") == 1 ) and not(autoRogue.tGStrike[1] == nil) and (not(UnitName("target") == nil) or not(UnitHealth("target") == 0)) then
            autoRogue.tGS[1] = autoRogue.tGStrike[1]
		else
			autoRogue.tGS[1] = nil
		end
		if autoRogue_isTargetDebuffUp("Spell_Shadow_LifeDrain") and ARData[ARPlayerRealm][ARPlayerName].Auto_Hemo == false or not(autoRogue.tHemo[1] == nil) then
			autoRogue.tHE[1] = autoRogue.tSinisterStrike[1]
		else		
			autoRogue.tHE[1] = autoRogue.tHemo[1]
		end
		if ARData[ARPlayerRealm][ARPlayerName].Auto_Riposte == true then
			autoRogue.tRi[1] = autoRogue.tRiposte[1]
		else
			autoRogue.tRi[1] = nil
		end
		if ARData[ARPlayerRealm][ARPlayerName].Auto_Kick == true and autoRogue.canKick == true then
			autoRogue.tKK[1] = autoRogue.tKick[1]
		else
			autoRogue.tKK[1] = nil
		end
		local kickstart, _, _ = GetActionCooldown(autoRogue.tKick[1])
		if ARData[ARPlayerRealm][ARPlayerName].Auto_Gouge == true and autoRogue.canKick == true and not(kickstart == 0) and not(UnitLevel("target") == -1) then
			autoRogue.tGG[1] = autoRogue.tGouge[1]
		else
			autoRogue.tGG[1] = nil
		end
					autoRogue.tRogueBF = { autoRogue.tAR, autoRogue.tBF, autoRogue.tGS, autoRogue.tFt, autoRogue.tSD, autoRogue.tKK, autoRogue.tGG }
					for key,t in autoRogue.tRogueBF do
			   			if (t[1]) then
			       			local isUsable, notEnoughMana = IsUsableAction(t[1])
			        		if (isUsable == 1) then
			           			local start, _, _ = GetActionCooldown(t[1])
			           			if (start == 0) then   -- not in cooldown
		              				if (IsActionInRange(t[1]) == 1 and AR_cp >= t[2]) then
											UseAction(t[1])
											if t[1] == autoRogue.tKK[1] or t[1] == autoRogue.tGG then
												autoRogue.canKick = false
											end
											break
										else
											UseAction(t[1])
											if t[1] == autoRogue.tKK[1] or t[1] == autoRogue.tGG then
												autoRogue.canKick = false
											end
										   	break
									end
								end
							end
						end
					end
end

function autoRogue.CheckCastlast()
				local ARmyunithp = UnitHealth("target")
				local AR_cp = GetComboPoints()
				local myautoRogueAR_cp = 5
				local AR_targetClass = nil
				local autoRogue_meleeTarget = false

		if ARData[ARPlayerRealm][ARPlayerName].Auto_Feint == true and ARmyunithp <= 95 and ( UnitAffectingCombat("player") == 1 ) and (not(UnitName("target") == nil) or not(UnitHealth("target") == 0)) then
			autoRogue.tFt[1] = autoRogue.tFeint[1]
		else
			autoRogue.tFt[1] = nil
		end
		autoRogue.tFinisher[1] = 5
end

function autoRogue_New_UseAction(slot, arg2, onself)
	if ARData[ARPlayerRealm][ARPlayerName].AutoRogueEnabled == true then
          	if (not GetActionText(slot)) then -- ignore any Player macros :-)
	         	local text = GetActionTexture(slot)
	         	if (text) then
		    		if (string.find(text, "Spell_Shadow_RitualOfSacrifice")) and not(autoRogue.fSinisterStrike == nil) then
	               		autoRogue.d("found Sinister Strike at slot "..slot)
							autoRogue.tSinisterStrike[1] = slot
							autoRogue.tSS[1] = autoRogue.tSinisterStrike[1]
	            	elseif (string.find(text, "Ability_BackStab")) and not(autoRogue.fBackStab == nil) then
	               		autoRogue.d("found BackStab at slot "..slot)
	               			autoRogue.tBackStab[1] = slot
	               			autoRogue.tBS[1] = autoRogue.tBackStab[1]
             		elseif (string.find(text, "Spell_Shadow_LifeDrain")) and not(autoRogue.fHemo == nil) then
              			autoRogue.d("found Hemorrhage at slot "..slot)
	            	    	autoRogue.tHemo[1] = slot
	            	    	autoRogue.tHE[1] = autoRogue.tHemo[1]
					end
	         	end
	         end
	         

			--hook these actions
			if slot == autoRogue.tSinisterStrike[1] then
				autoRogue_SS()
			elseif slot == autoRogue.tBackStab[1] then
				autoRogue_BS()
			elseif slot == autoRogue.tHemo[1] then
				autoRogue_HM()
			else
				autoRogue_Orig_UseAction(slot, arg2, onself)
			end
	else
		autoRogue_Orig_UseAction(slot, arg2, onself)	
	end
end
function autoRogue_SS()
                autoRogue.CheckCastfirst()
				autoRogue.CheckCastCDbuffs()
				local AR_cp = GetComboPoints()
					autoRogue.tRogueSS = { autoRogue.tFinisher, autoRogue.tSS, autoRogue.tRi, autoRogue.tKILL }
					for key,t in autoRogue.tRogueSS do
			   			if (t[1]) then
			       			local isUsable, notEnoughMana = IsUsableAction(t[1])
			        		if (isUsable == 1) then
			           			local start, _, _ = GetActionCooldown(t[1])
			           			if (start == 0) then   -- not in cooldown
		              				if (IsActionInRange(t[1]) == 1 and AR_cp >= t[2]) then
										if not(t[1] == autoRogue.tSinisterStrike[1]) then
											if t[1] == autoRogue.tEviscerate[1] and ARData[ARPlayerRealm][ARPlayerName].Auto_ColdBlood == true and AR_cp == 5 then
                                                autoRogue.CastCB()
												UseAction(t[1])
										   		break
											elseif t[1] == autoRogue.tEviscerate[1] and ARData[ARPlayerRealm][ARPlayerName].Auto_ColdBlood == true and autoRogue.IsEviscKillShot() == true then
												autoRogue.CastCB()
												UseAction(t[1])
										   		break
											else
												UseAction(t[1])
										   		break
											end
										else
                    						autoRogue.CastSS()
											break
										end
									end
								end
							end
						end
					end

				autoRogue.CheckCastlast()
end

function autoRogue_BS()
				local AR_cp = GetComboPoints()
                autoRogue.CheckCastfirst()
					autoRogue.tRogueBS = { autoRogue.tFinisher, autoRogue.tBS, autoRogue.tRi, autoRogue.tKILL }
					for key,t in autoRogue.tRogueBS do
			   			if (t[1]) then
			       			local isUsable, notEnoughMana = IsUsableAction(t[1])
			        		if (isUsable == 1) then
			           			local start, _, _ = GetActionCooldown(t[1])
			           			if (start == 0) then   -- not in cooldown
		              				if (IsActionInRange(t[1]) == 1 and AR_cp >= t[2]) then
										if not(t[1] == autoRogue.tBackStab[1]) then
											UseAction(t[1])
										   	break
										else
           									autoRogue.CastBS()
											break
										end
									end
								end
							end
						end
					end
				autoRogue.CheckCastCDbuffs()
                autoRogue.CheckCastlast()
end

function autoRogue_HM()
                autoRogue.CheckCastfirst()
				autoRogue.CheckCastCDbuffs()
				local AR_cp = GetComboPoints()
					autoRogue.tRogueHM = { autoRogue.tFinisher, autoRogue.tHE, autoRogue.tRi, autoRogue.tKILL }
					for key,t in autoRogue.tRogueHM do
			   			if (t[1]) then
			       			local isUsable, notEnoughMana = IsUsableAction(t[1])
			        		if (isUsable == 1) then
			           			local start, _, _ = GetActionCooldown(t[1])
			           			if (start == 0) then   -- not in cooldown
		              				if (IsActionInRange(t[1]) == 1 and AR_cp >= t[2]) then
										if not(t[1] == autoRogue.tHemo[1]) then
											if t[1] == autoRogue.tEviscerate[1] and ARData[ARPlayerRealm][ARPlayerName].Auto_ColdBlood == true and AR_cp == 5 then
												autoRogue.CastCB()
												UseAction(t[1])
										   		break
											elseif t[1] == autoRogue.tEviscerate[1] and ARData[ARPlayerRealm][ARPlayerName].Auto_ColdBlood == true and autoRogue.IsEviscKillShot() == true then
												autoRogue.CastCB()
												UseAction(t[1])
										   		break
											else
												UseAction(t[1])
										   		break
											end
										else
                    						autoRogue.CastHE()
											break
										end
									end
								end
							end
						end
					end
				autoRogue.CheckCastlast()
end

local function ARMobHP_PPP(index)
	if not(ARMobHPDB == nil) then
	if( index and ARMobHPDB[index] ) then
		local s, e;
		local pts;
		local pct;

		s, e, pts, pct = string.find(ARMobHPDB[index], "^(%d+)/(%d+)$");
		if( pts and pct ) then
			pts = pts + 0;
			pct = pct + 0;
			if( pct ~= 0 ) then
				return pts / pct;
			end
		end
	end
	return 0;
	end
end

local function ARMobHP_Pts(index)
	if not(ARMobHPDB == nil) then
	if( index and ARMobHPDB[index] ) then
		local s, e;
		local val;

		s, e, val = string.find(ARMobHPDB[index], "^(%d+)/");

		if( val ) then
			return val + 0;
		end
	end
	return 0;
	end
end

local function ARMobHP_Pct(index)
	if not(ARMobHPDB == nil) then
	if( index and ARMobHPDB[index] ) then
		local s, e;
		local val;

		s, e, val = string.find(ARMobHPDB[index], "/(%d+)$");

		if( val ) then
			return val + 0;
		end
	end
	return 0;
	end
end

local function ARMobHP_Set(index, pts, pct)
		if UnitName("target") == nil or UnitHealth("target") == 0 or ARTargetHP == 0.5 then
  			ARTargetHP = 10000000
		end
	if( index ) then
		if( pts ) then
			pts = pts + 0;
		else
			pts = 0;
		end
		if( pct ) then
			pct = pct + 0;
		else
			pct = 0;
		end
		if( pts == 0 and pct == 0 ) then
			ARMobHPDB[index] = nil;
		else
			ARMobHPDB[index] = pts.."/"..pct;
		end
	end
end

local function ARMobHP_Display(currentPct, index)
	local field = getglobal("ARMobHPText");
	local text = "";
		if UnitName("target") == nil or UnitHealth("target") == 0 or ARTargetHP == 0.5 then
  			ARTargetHP = 10000000
		end

	if( field ) then
		local pointsPerPct = ARMobHP_PPP(index);
		if( pointsPerPct > 0 ) then
			if( currentPct ) then
				text = string.format("%d/%d", (currentPct * pointsPerPct) + 0.5, (100 * pointsPerPct) + 0.5);

			else
				text = string.format("???/%d", (100 * pointsPerPct) + 0.5);
			end
		end
		--field:SetText(text);
	end
end

local function ARMobHP_VariablesLoaded()
	if( not ARMobHPDB ) then
		ARMobHPDB = { };
	else
		local index, value;

		for index, value in ARMobHPDB do
			-- Convert the old-style data into the newer, more compact form
			if( type(value) == "table" ) then
				ARMobHP_Set(index, value.damPts, value.damPct);
			end
		end
	end
end

function autoRogue.ScanSpellsAndBars()
	--Scan for spells
	for id = 1, 180, 1 do
		local spellName, subSpellName = GetSpellTexture(id, SpellBookFrame.bookType)
		if spellName and string.find(spellName, "Spell_Shadow_RitualOfSacrifice", 1, true) then
			autoRogue.d("Sinister Strike Spellbook ID is "..id, 1.0, 1.0, 0.5);
			autoRogue.fSinisterStrike = id
		elseif spellName and string.find(spellName, "Ability_Rogue_Feint", 1, true) then
			autoRogue.d("Feint Spellbook ID is "..id, 1.0, 1.0, 0.5);
			autoRogue.fFeint = id
		elseif spellName and string.find(spellName, "Ability_BackStab", 1, true) then
			autoRogue.d("BackStab Spellbook ID is "..id, 1.0, 1.0, 0.5);
			autoRogue.fBackStab = id
		elseif spellName and string.find(spellName, "Ability_Rogue_SliceDice", 1, true) then
			autoRogue.d("Slice and Dice Spellbook ID is "..id, 1.0, 1.0, 0.5);
			autoRogue.fSliceDice = id
		elseif spellName and string.find(spellName, "Spell_Ice_Lament", 1, true) then
			autoRogue.d("Cold Blood Spellbook ID is "..id, 1.0, 1.0, 0.5);
 			autoRogue.fColdBlood = id
		elseif spellName and string.find(spellName, "Ability_Rogue_KidneyShot", 1, true) then
			autoRogue.d("KidneyShot Spellbook ID is "..id, 1.0, 1.0, 0.5);
 			autoRogue.fKidneyShot = id
		elseif spellName and string.find(spellName, "Ability_Rogue_Eviscerate", 1, true) then
				autoRogue.d("Eviscerate Spellbook ID is "..id, 1.0, 1.0, 0.5);
			autoRogue.fEviscerate = id
		elseif spellName and string.find(spellName, "Ability_Warrior_Riposte", 1, true) then
				autoRogue.d("Expose Armor Spellbook ID is "..id, 1.0, 1.0, 0.5);
			autoRogue.fExpose = id
		elseif spellName and string.find(spellName, "Ability_Rogue_Rupture", 1, true) then
				autoRogue.d("Rupture Spellbook ID is "..id, 1.0, 1.0, 0.5);
			autoRogue.fRupture = id
		elseif spellName and string.find(spellName, "Spell_Shadow_Curse", 1, true) then
				autoRogue.d("Ghostly Strike Spellbook ID is "..id, 1.0, 1.0, 0.5);
			autoRogue.fGStrike = id
		elseif spellName and string.find(spellName, "Ability_Kick", 1, true) then
				autoRogue.d("Kick Spellbook ID is "..id, 1.0, 1.0, 0.5);
			autoRogue.fKick = id
		elseif spellName and string.find(spellName, "Ability_Warrior_Challange", 1, true) then
				autoRogue.d("Riposte Spellbook ID is "..id, 1.0, 1.0, 0.5);
			autoRogue.fRiposte = id
		elseif spellName and string.find(spellName, "Ability_Vanish", 1, true) then
				autoRogue.d("Vanish Spellbook ID is "..id, 1.0, 1.0, 0.5);
			autoRogue.fVanish = id
		elseif spellName and string.find(spellName, "Spell_Shadow_LifeDrain", 1, true) then
				autoRogue.d("Hemorrhage Spellbook ID is "..id, 1.0, 1.0, 0.5);
			autoRogue.fHemo = id
		elseif spellName and string.find(spellName, "Ability_Warrior_PunishingBlow", 1, true) then
			autoRogue.d("Blade Flurry Spellbook ID is "..id, 1.0, 1.0, 0.5);
			autoRogue.fBFlurry = id
		elseif spellName and string.find(spellName, "Spell_Shadow_ShadowWordDominate", 1, true) then
			autoRogue.d("Adrenaline Rush Spellbook ID is "..id, 1.0, 1.0, 0.5);
			autoRogue.fARush = id
		elseif spellName and string.find(spellName, "Spell_Shadow_ShadowWard", 1, true) then
			autoRogue.d("Evasion Spellbook ID is "..id, 1.0, 1.0, 0.5);
			autoRogue.fEvas = id
		elseif spellName and string.find(spellName, "Ability_Gouge", 1, true) then
			autoRogue.d("Gouge Spellbook ID is "..id, 1.0, 1.0, 0.5);
			autoRogue.fGouge = id
		end;
	end;
  autoRogue.d("## rescanning action bar...")


  for bag=0,4 do
    for slot=1,GetContainerNumSlots(bag) do
      if (GetContainerItemLink(bag,slot)) then
        if (string.find(GetContainerItemLink(bag,slot), "Thistle Tea")) then
          autoRogue.tTea[1] = slot
          autoRogue.tTea[2] = bag
        end
      end
    end
  end
  
 	--Scanning actions
   local slot
   for slot=1, 120, 1 do
      if (not GetActionText(slot)) then -- ignore any Player macros :-)
         local text = GetActionTexture(slot)
         if (text) then
	    	if (string.find(text, "Spell_Shadow_RitualOfSacrifice")) and not(autoRogue.fSinisterStrike == nil) then 
               autoRogue.d("found Sinister Strike at slot "..slot)
               autoRogue.tSinisterStrike[1] = slot
            elseif (string.find(text, "Ability_BackStab")) and not(autoRogue.fBackStab == nil) then
               autoRogue.d("found BackStab at slot "..slot)
               autoRogue.tBackStab[1] = slot
            elseif (string.find(text, "Ability_Rogue_Feint")) and not(autoRogue.fFeint == nil) then
               autoRogue.d("found Feint at slot "..slot)
               autoRogue.tFeint[1] = slot
            elseif (string.find(text, "Ability_Rogue_SliceDice")) and not(autoRogue.fSliceDice == nil) then
               autoRogue.d("found SliceDice at slot "..slot)
               autoRogue.tSliceDice[1] = slot
            elseif (string.find(text, "Spell_Ice_Lament")) and not(autoRogue.fColdBlood == nil) then
               autoRogue.d("found Cold Blood at slot "..slot)
               autoRogue.tColdBlood[1] = slot
             elseif (string.find(text, "Ability_Rogue_Eviscerate")) and not(autoRogue.fEviscerate == nil) then
               autoRogue.d("found Eviscerate at slot "..slot)
               autoRogue.tEviscerate[1] = slot
             elseif (string.find(text, "Ability_Rogue_KidneyShot")) and not(autoRogue.fKidneyShot == nil) then
               autoRogue.d("found KidneyShot at slot "..slot)
               autoRogue.tKidneyShot[1] = slot
             elseif (string.find(text, "Ability_Rogue_Rupture")) and not(autoRogue.fRupture == nil) then
               autoRogue.d("found Rupture at slot "..slot)
               autoRogue.tRupture[1] = slot
             elseif (string.find(text, "Spell_Shadow_Curse")) and not(autoRogue.fGStrike == nil) then
               autoRogue.d("found Ghostly Strike at slot "..slot)
               autoRogue.tGStrike[1] = slot
             elseif (string.find(text, "Ability_Warrior_Riposte")) and not(autoRogue.fExpose == nil) then
               autoRogue.d("found Expose Armor at slot "..slot)
               autoRogue.tExpose[1] = slot
             elseif (string.find(text, "Ability_Rogue_Ambush")) and not(autoRogue.fExpose == nil) then
               autoRogue.d("found Ambush Armor at slot "..slot)
               autoRogue.tAmbush[1] = slot
             elseif (string.find(text, "Ability_Kick")) and not(autoRogue.fKick == nil) then
               autoRogue.d("found Kick at slot "..slot)
               autoRogue.tKick[1] = slot
             elseif (string.find(text, "Ability_Warrior_Challange")) and not(autoRogue.fRiposte == nil) then
               autoRogue.d("found Riposte at slot "..slot)
               autoRogue.tRiposte[1] = slot
             elseif (string.find(text, "Ability_Vanish")) and not(autoRogue.fVanish == nil) then
               autoRogue.d("found Vanish at slot "..slot)
               autoRogue.tVanish[1] = slot
             elseif (string.find(text, "Spell_Shadow_LifeDrain")) and not(autoRogue.fHemo == nil) then
               autoRogue.d("found Hemorrhage at slot "..slot)
               autoRogue.tHemo[1] = slot
             elseif (string.find(text, "Ability_Warrior_PunishingBlow")) and not(autoRogue.fBFlurry == nil) then
               autoRogue.d("found Blade Flurry at slot "..slot)
               autoRogue.tBFlurry[1] = slot
             elseif (string.find(text, "Spell_Shadow_ShadowWordDominate")) and not(autoRogue.fARush == nil) then
               autoRogue.d("found Adrenaline Rush at slot "..slot)
               autoRogue.tARush[1] = slot
             elseif (string.find(text, "Spell_Shadow_ShadowWard")) and not(autoRogue.fEvas == nil) then
               autoRogue.d("found Evasion at slot "..slot)
               autoRogue.tEvas[1] = slot
             elseif (string.find(text, "Ability_Gouge")) and not(autoRogue.fGouge == nil) then
               autoRogue.d("found Gouge at slot "..slot)
               autoRogue.tGouge[1] = slot
			end
         end
      end
   end         
end

function autoRogue.CastSS()
	if not(autoRogue.fSinisterStrike == nil) then
		local start, duration = GetSpellCooldown(autoRogue.fSinisterStrike, "spell");
		local isUsable, notEnoughMana = IsUsableAction(autoRogue.tSinisterStrike[1])
		if (isUsable == 1) then
        	if not( start > 0 and duration > 0) then
				CastSpell( autoRogue.fSinisterStrike, "spell")
			end
		end
	end	 
end

function autoRogue.CastF()
	if not(autoRogue.fFeint == nil) then
		local start, duration = GetSpellCooldown(autoRogue.fFeint, "spell");
        if not( start > 0 and duration > 0) then
   			CastSpell( autoRogue.fFeint, "spell")
		end	
	end 
end

function autoRogue.CastBS()
	if not(autoRogue.fBackStab == nil) then
		local start, duration = GetSpellCooldown(autoRogue.fBackStab, "spell");
        if not( start > 0 and duration > 0) then	
			CastSpell( autoRogue.fBackStab, "spell")	
		end	
	end 
end

function autoRogue.CastSD()
	if not(autoRogue.fSliceDice == nil) then
		local start, duration = GetSpellCooldown(autoRogue.fSliceDice, "spell");
        if not( start > 0 and duration > 0) then
			if not(autoRogue_isTargetStunned() == true) then
				autoRogue.CheckCastSD(autoRogue.fSliceDice)
				autoRogue.d("flagged as clear in CastSD")	
			end
		end	
	end 
end

function autoRogue.CastaltSD()
  local Counter = 1
  local Buff = GetSpellTexture(autoRogue.fSliceDice, 0)
  while (UnitBuff("player", Counter)) do
   	if (GetPlayerBuffTexture(Counter) == Buff) then
		if GetPlayerBuffTimeLeft(Counter) <=5 and not(GetComboPoints() == 5) then 
			  autoRogue.CastEV()
  			--autoRogue.p("Eviscerate dumped at "..GetPlayerBuffTimeLeft(Counter).." seconds")
  	  	end
	    return
    end
    Counter = Counter + 1
  end
		if (GetComboPoints() == autoRogue.SnDpt) and not(GetComboPoints() == 5)  then
			if not(autoRogue_isTargetStunned()) then
				autoRogue.d("flagged as clear in CastaltSD SD")
				autoRogue.CastSD()
			else
				autoRogue.CastEV()
			end	
		end
end

function autoRogue.CastaltVA()
  local Counter = 1
  local Buff = GetSpellTexture(autoRogue.fEvas, 0)
  while (UnitBuff("player", Counter)) do
   	if (GetPlayerBuffTexture(Counter) == Buff) then
		if GetPlayerBuffTimeLeft(Counter) <=3 then 
			  autoRogue.CastVA()
  			--autoRogue.p("Eviscerate dumped at "..GetPlayerBuffTimeLeft(Counter).." seconds")
  	  	end
	    return
    end
    Counter = Counter + 1
  end
end

function autoRogue_isUnitDebuffUp(sUnitname, sDebuffname)
  local iIterator = 1
  while (UnitDebuff(sUnitname, iIterator)) do
    if (string.find(UnitDebuff(sUnitname, iIterator), sDebuffname)) then
      	autoRogue.d(sDebuffname.." is on target")
	  return true
    end
    iIterator = iIterator + 1
  end
  return false
end

function autoRogue_isTargetDebuffUp(sDebuffname)
  if not sDebuffname then 
  	autoRogue.d("isTargetDebuffUp:sBuffname empty")
  	return false
  end;
  return autoRogue_isUnitDebuffUp("target", sDebuffname)
end;

function autoRogue_isTargetStunned()
  if UnitIsFriend("player","target") then 
  	 return false 
  end;
  
  if autoRogue_isTargetDebuffUp("Ability_Gouge") or autoRogue_isTargetDebuffUp("Ability_CheapShot") or autoRogue_isTargetDebuffUp("Ability_Rogue_KidneyShot") then
  	autoRogue.d("Target is Stunned")
  	return true  
  else
  	autoRogue.d("Target is not Stunned")
  	return false  
  end;
end;

-- Checks if a buff is active on the player. If not, it will be cast
function autoRogue.CheckCastSD(SpellID) 
  local Counter = 1
  local Buff = GetSpellTexture(SpellID, 0)
  while (UnitBuff("player", Counter)) do
    if (UnitBuff("player", Counter) == Buff) then
      return
    end
    Counter = Counter + 1
  end
  CastSpell(SpellID, 0)
end

function autoRogue.CastCB()
	if not(autoRogue.fColdBlood == nil) then
		local start, duration = GetSpellCooldown(autoRogue.fColdBlood, "spell");
        if not( start > 0 and duration > 0) then
			CastSpell( autoRogue.fColdBlood, "spell")
			SpellStopCasting()	
		end	
	end 
end

function autoRogue.CastKS()
	if not(autoRogue.fKidneyShot == nil) then
		local start, duration = GetSpellCooldown(autoRogue.fKidneyShot, "spell");
        if not( start > 0 and duration > 0) then
			CastSpell( autoRogue.fKidneyShot, "spell")
		else
			if GetComboPoints() >= 1 then
				autoRogue.CastEV()
			end		
		end
	end 
end

function autoRogue.CastEV()
	local cbAR_cp = GetComboPoints()
	if not(autoRogue.fEviscerate == nil) then
		local start, duration = GetSpellCooldown(autoRogue.fEviscerate, "spell");
        if not( start > 0 and duration > 0) then
			if ARData[ARPlayerRealm][ARPlayerName].Auto_ColdBlood == true and cbAR_cp == 5 or ARData[ARPlayerRealm][ARPlayerName].Auto_ColdBlood == true and autoRogue.IsEviscKillShot() == true then
				autoRogue.CastCB()
				CastSpell( autoRogue.fEviscerate, "spell")
			else
				CastSpell( autoRogue.fEviscerate, "spell")
			end
			if autoRogue.IsEviscKillShot() == true then
				autoRogue.da(killshotmsg)
			end	
		end
	end 
end 

function autoRogue.CastEX()
	if not(autoRogue.fExpose == nil) then
		local start, duration = GetSpellCooldown(autoRogue.fExpose, "spell");
        if not( start > 0 and duration > 0) then
			CastSpell( autoRogue.fExpose, "spell")	
		end	
	end 
end

function autoRogue.CastRU()
	if not(autoRogue.fRupture == nil) then
		local start, duration = GetSpellCooldown(autoRogue.fRupture, "spell");
        if not( start > 0 and duration > 0) then
			if not(autoRogue_CurrActiveBuff("rupture", "target")) then
				CastSpell( autoRogue.fRupture, "spell")
			else
				autoRogue.da("rupture allready cast Eviscerating instead!")
				autoRogue.CastEV()
			end	
		end
	end 
end

function autoRogue.CastHE()
	if not(autoRogue.fHemo == nil) then
		local start, duration = GetSpellCooldown(autoRogue.fHemo, "spell");
        if not( start > 0 and duration > 0) then
			if not(autoRogue_CurrActiveBuff("Hemorrhage", "target")) then
				CastSpell( autoRogue.fHemo, "spell")
			else
				autoRogue.da("Hemorrhage allready cast Eviscerating instead!")
				autoRogue.CastSS()
			end	
		end
	end 
end

function autoRogue.CastRP()
	if not(autoRogue.fRiposte == nil) then
		local start, duration = GetSpellCooldown(autoRogue.fRiposte, "spell");
        if not( start > 0 and duration > 0) then
			CastSpell( autoRogue.fRiposte, "spell")	
		end
	end 
end

function autoRogue.CastBF()
	if not(autoRogue.fBFlurry == nil) then
		local start, duration = GetSpellCooldown(autoRogue.fBFlurry, "spell");
        if not( start > 0 and duration > 0) then
				CastSpell( autoRogue.fBFlurry, "spell")
		end
	end
end

function autoRogue.CastEVA()
	if not(autoRogue.fEvas == nil) then
		local start, duration = GetSpellCooldown(autoRogue.fEvas, "spell");
        if not( start > 0 and duration > 0) then
			CastSpell( autoRogue.fEvas, "spell")
		end
	end
end

function autoRogue.CastAR()
	if not(autoRogue.fARush == nil) then
		local start, duration = GetSpellCooldown(autoRogue.fARush, "spell");
        if not( start > 0 and duration > 0) then
			CastSpell( autoRogue.fARush, "spell")
		end
	end
end

function autoRogue.CastGS()
	if not(autoRogue.fGStrike == nil) then
		local start, duration = GetSpellCooldown(autoRogue.fGStrike, "spell");
        if not( start > 0 and duration > 0) then
			CastSpell( autoRogue.fGStrike, "spell")
		end
	end
end

function autoRogue.UseTrinket1()
	if not(autoRogue_GetItemName(13) == nil) then
		autoRogue.trinket1 = autoRogue_GetItemName(13)
		local _,arT1Cooldown,isT1usable=GetInventoryItemCooldown("player",13);
		if arT1Cooldown <= 0 and (isT1usable == 1) and not(autoRogue.trinket1 == "") then
			autoRogue.d(autoRogue_GetItemName(13).." is ready and usable")
		else
			autoRogue.d(autoRogue_GetItemName(13).." is not ready or usable")
		end
		if (isT1usable == 1) then
			UseInventoryItem(13)
		end
	end
end

function autoRogue.UseTrinket2()
	if not(autoRogue_GetItemName(14) == nil) then
		autoRogue.trinket2 = autoRogue_GetItemName(14)
		local _,arT2Cooldown,isT2usable=GetInventoryItemCooldown("player",14);
		if arT2Cooldown <= 0 and (isT2usable == 1) and not(autoRogue.trinket2 == "") then
			autoRogue.d(autoRogue_GetItemName(14).." is ready and usable")
		else
			autoRogue.d(autoRogue_GetItemName(14).." is not ready or usable")
		end
		if (isT2usable == 1) then
			UseInventoryItem(14)
		end
	end
end

function autoRogue.CastKI()
	if not(autoRogue.fKick == nil) then
	local start, duration = GetSpellCooldown(autoRogue.fKick, "spell");
		if not( start > 0 and duration > 0) then
			if not (autoRogue_CurrActiveBuff("Gouge", "target")) and not(autoRogue_CurrActiveBuff("Cheap Shot", "target")) and not(autoRogue_CurrActiveBuff("Kidney Shot", "target")) then
				CastSpell( autoRogue.fKick, "spell")
			end
		end
	end
end


function autoRogue.CastAM()
	if not(autoRogue.fAmbush == nil) then
		local start, duration = GetSpellCooldown(autoRogue.fAmbush, "spell");
        if not( start > 0 and duration > 0) then
			CastSpell( autoRogue.fAmbush, "spell")
		end
	end
end

function autoRogue.CastVA()
	if not(autoRogue.fVanish == nil) then
		local start, duration = GetSpellCooldown(autoRogue.fVanish, "spell");
        if not( start > 0 and duration > 0) then
			CastSpell( autoRogue.fVanish, "spell")
		end
	end
end

function autoRogue.CastTEA()
local ARenergy = 20
	if UnitMana("Player") <= (ARenergy) then
		if not(autoRogue.tTea[1] == nil) then 
			if (GetContainerItemCooldown(autoRogue.tTea[2],autoRogue.tTea[1])==0) then 
				UseContainerItem(autoRogue.tTea[2],autoRogue.tTea[1])  
			end
		end
	end
end

function autoRogue_CurrActiveBuff(buffname, unit)
	if (not buffname) then
		return;
	end;
	if (not unit) then
		unit="player";
	end;
	if string.lower(unit) == "mainhand" then
		IsBuffActiveTooltip:ClearLines();
		CurrActiveBuff:SetInventoryItem("player",GetInventorySlotInfo("MainHandSlot"));
		for i = 1,CurrActiveBuff:NumLines() do
			if string.find((getglobal("CurrActiveBuffTextLeft"..i):GetText() or ""),buffname) then
				autoRogue.p(i)
				return true
			end;
		end
		return false
	end
	if string.lower(unit) == "offhand" then
		CurrActiveBuff:ClearLines();
		CurrActiveBuff:SetInventoryItem("player",GetInventorySlotInfo("SecondaryHandSlot"));
		for i=1,CurrActiveBuff:NumLines() do
			if string.find((getglobal("CurrActiveBuffTextLeft"..i):GetText() or ""),buffname) then
				autoRogue.p(i)
				return true
			end;
		end
		return false
	end
  local i = 1;
  while UnitBuff(unit, i) do 
		CurrActiveBuff:ClearLines();
		CurrActiveBuff:SetUnitBuff(unit,i);
    if string.find(CurrActiveBuffTextLeft1:GetText() or "", buffname) then
      autoRogue.p(i)
	  return true, i
    end;
    i = i + 1;
  end;
  local i = 1;
  while UnitDebuff(unit, i) do 
		CurrActiveBuff:ClearLines();
		CurrActiveBuff:SetUnitDebuff(unit,i);
    if string.find(CurrActiveBuffTextLeft1:GetText() or "", buffname) then
      autoRogue.p(i)
	  return true, i
    end;
    i = i + 1;
  end;
end

function autoRogue.CheckEX()
	local exp = false
	for i=1,16 do t=UnitDebuff("target", i)
		if (t and string.find(t,"Ability_Warrior_Riposte")) then		
			return true
		end
		return false
	end
end

function autoRogue.CheckRU()
	local exp = false
	for i=1,16 do t=UnitDebuff("target", i)
		if (t and string.find(t,"Ability_Rogue_Rupture")) then		
			return true
		end
		return false
	end
end

-- Function: 		ARInitialize()
-- Arguments:		None
-- Returns:  		None
-- Used for: 		Register Slash Commands and calls ARInitializeARData to initialize ARData incase it isn't already in SavedVariables
function ARInitialize()
  SLASH_AutoRogue1 = "/AutoRogue";
  SLASH_AutoRogue2 = "/ar";
  SlashCmdList["AutoRogue"] = function(msg)
		ARCommand(msg);
	end
	ARInitializeARData()
    autoRogue_CheckTrinkets()
end



-- Function: 		ARCommand()
-- Returns:  		None
-- Used for: 		Handles all the slash commands
function ARCommand(msg)
	if msg == "" then
		AutoRogue_Toggle()
	elseif msg == "help" then
		autoRogue_out("Commands are");
		autoRogue_out("/ar".."     to toggle the options UI");
		autoRogue_out("/ar".."     to display this help information");
		autoRogue_out("/ar ss".."  to cast AutoRogue's Sinister Strike");
		autoRogue_out("/ar hm".."  to cast AutoRogue's Hemhorrage");
		autoRogue_out("/ar bs".."  to cast AutoRogue's BackStab");
	elseif msg == "ss" then
		autoRogue_SS()
	elseif msg == "bs" then 
	    autoRogue_BS()
	elseif msg == "hm" then
		autoRogue_HM()
	else
		autoRogue_out(msg.." is an invalid command, type /ar help for options");
	end
end

function AutoRogue_Toggle()
	if(AutoRogueOptionsFrame:IsVisible()) then
		AutoRogueOptionsFrame:Hide();
		autoRogue.AutoRogueShown = false;
	else
		AutoRogueOptionsFrame:Show();
		DEFAULT_CHAT_FRAME:AddMessage("[AUTOROGUE] "..autoRogue.version..autoRogue_CHATMESSAGE, .1, .7, .75);
		PlaySound("igMainMenuOpen")
		autoRogue.AutoRogueShown = true;
	end
end

-- Function: 		ARInitializeARData()
-- Arguments:		None
-- Returns:  		None
-- Used for: 		Initializes ARData incase it isn't already in SavedVariables
function ARInitializeARData()
	if (ARData == nil) then
		ARData = {};
	end
	
	if (ARData[ARPlayerRealm] == nil) then
		ARData[ARPlayerRealm] = {};
	end

	if (ARPlayerName ~= nil and ARPlayerName ~= UNKNOWNOBJECT and ARPlayerName ~= UKNOWNBEING) then
		if (ARData[ARPlayerRealm][ARPlayerName] == nil) then
			ARData[ARPlayerRealm][ARPlayerName] = {};
			ARSetDefaultOptions();
		end
	end
end

function ARSetDefaultOptions()
autoRogue.p("new player detected setting default options...")
	ARData[ARPlayerRealm][ARPlayerName].Auto_Feint = true;
	ARData[ARPlayerRealm][ARPlayerName].Auto_Kidney = true;
	ARData[ARPlayerRealm][ARPlayerName].Auto_Evis_Low = true;
	ARData[ARPlayerRealm][ARPlayerName].Auto_Evis_High = true;
	ARData[ARPlayerRealm][ARPlayerName].Auto_SliceDice = true;
	ARData[ARPlayerRealm][ARPlayerName].Auto_Kick = true;
	ARData[ARPlayerRealm][ARPlayerName].Auto_Riposte = true;
	ARData[ARPlayerRealm][ARPlayerName].Auto_GStrike = true;
	ARData[ARPlayerRealm][ARPlayerName].Auto_Vanish = true
	ARData[ARPlayerRealm][ARPlayerName].Auto_BFlurry = true
	ARData[ARPlayerRealm][ARPlayerName].Auto_ARush = true
	ARData[ARPlayerRealm][ARPlayerName].Auto_Evasion = true
	ARData[ARPlayerRealm][ARPlayerName].Auto_ColdBlood = true;
	ARData[ARPlayerRealm][ARPlayerName].Finisher = "Eviscerate";
	ARData[ARPlayerRealm][ARPlayerName].SnDDump = "Eviscerate";
	ARData[ARPlayerRealm][ARPlayerName].Auto_SliceDiceDump = true
	ARData[ARPlayerRealm][ARPlayerName].SnDpt = 2
	ARData[ARPlayerRealm][ARPlayerName].Auto_Trinket2 = true
	ARData[ARPlayerRealm][ARPlayerName].Auto_Trinket2 = true
	ARData[ARPlayerRealm][ARPlayerName].AutoRogueEnabled = true
	ARData[ARPlayerRealm][ARPlayerName].Auto_Tea = true
	ARData[ARPlayerRealm][ARPlayerName].Auto_Hemo = true
	ARData[ARPlayerRealm][ARPlayerName].Auto_Gouge = true
end

-- Used for:        Sets the slider options
function ARSetSliderOptions()

	ARData[ARPlayerRealm][ARPlayerName].SnDpt = autoRogue.SnDpt
end

-- Function: 		AROptionsFrame_OnShow()
-- Arguments:		None
-- Returns:  		None
-- Used for: 		Populates checkboxes of options panel when it is opened
function AROptionsFrame_OnShow()	

	if (ARData[ARPlayerRealm][ARPlayerName].Auto_Feint) then
		ARCheckBoxAuto_Feint:SetChecked(1);
	else
		ARCheckBoxAuto_Feint:SetChecked(0);
	end
	
	if (ARData[ARPlayerRealm][ARPlayerName].Auto_Riposte) then
		ARCheckBoxAuto_Riposte:SetChecked(1);
	else
		ARCheckBoxAuto_Riposte:SetChecked(0);
	end
	
	if (ARData[ARPlayerRealm][ARPlayerName].Auto_SliceDice) then
		ARCheckBoxAuto_SliceDice:SetChecked(1);
	else
		ARCheckBoxAuto_SliceDice:SetChecked(0);
	end

	if (ARData[ARPlayerRealm][ARPlayerName].Auto_SliceDiceDump) then
		ARCheckBoxAuto_SliceDiceDump:SetChecked(1);
	else
		ARCheckBoxAuto_SliceDiceDump:SetChecked(0);
	end

	if (ARData[ARPlayerRealm][ARPlayerName].Auto_Kidney) then
		ARCheckBoxAuto_Kidney:SetChecked(1);
	else
		ARCheckBoxAuto_Kidney:SetChecked(0);
	end

	if (ARData[ARPlayerRealm][ARPlayerName].Auto_Evis_Low) then
		ARCheckBoxAuto_Evis_Low:SetChecked(1);
	else
		ARCheckBoxAuto_Evis_Low:SetChecked(0);
	end

	if (ARData[ARPlayerRealm][ARPlayerName].Auto_Kick) then
		ARCheckBoxAuto_AutoKick:SetChecked(1);
	else
		ARCheckBoxAuto_AutoKick:SetChecked(0);
	end

	if (ARData[ARPlayerRealm][ARPlayerName].Auto_Evis_High) then
		ARCheckBoxAuto_Evis_High:SetChecked(1);
	else
		ARCheckBoxAuto_Evis_High:SetChecked(0);
	end
	
	if (ARData[ARPlayerRealm][ARPlayerName].Auto_Vanish) then
		ARCheckBoxAuto_Vanish:SetChecked(1);
	else
		ARCheckBoxAuto_Vanish:SetChecked(0);
	end
	
	if (ARData[ARPlayerRealm][ARPlayerName].Auto_BFlurry) then
		ARCheckBoxAuto_BFlurry:SetChecked(1);
	else
		ARCheckBoxAuto_BFlurry:SetChecked(0);
	end
	
	if (ARData[ARPlayerRealm][ARPlayerName].Auto_ARush) then
		ARCheckBoxAuto_ARush:SetChecked(1);
	else
		ARCheckBoxAuto_ARush:SetChecked(0);
	end

	if (ARData[ARPlayerRealm][ARPlayerName].Auto_GStrike) then
		ARCheckBoxAuto_GStrike:SetChecked(1);
	else
		ARCheckBoxAuto_GStrike:SetChecked(0);
	end
	
	if (ARData[ARPlayerRealm][ARPlayerName].Auto_Evasion) then
		ARCheckBoxAuto_Evasion:SetChecked(1);
	else
		ARCheckBoxAuto_Evasion:SetChecked(0);
	end

	if (ARData[ARPlayerRealm][ARPlayerName].Auto_Trinket1) then
		ARCheckBoxAuto_TRINKET1:SetChecked(1);
	else
		ARCheckBoxAuto_TRINKET1:SetChecked(0);
	end

    if (ARData[ARPlayerRealm][ARPlayerName].Auto_Trinket2) then
		ARCheckBoxAuto_TRINKET2:SetChecked(1);
	else
		ARCheckBoxAuto_TRINKET2:SetChecked(0);
	end
	
    if (ARData[ARPlayerRealm][ARPlayerName].Auto_ColdBlood) then
		ARCheckBoxAuto_COLDBLOOD:SetChecked(1);
	else
		ARCheckBoxAuto_COLDBLOOD:SetChecked(0);
	end	

    if (ARData[ARPlayerRealm][ARPlayerName].AutoRogueEnabled) then
		ARCheckBoxAuto_ENABLE:SetChecked(1);
	else
		ARCheckBoxAuto_ENABLE:SetChecked(0);
	end
	
    if (ARData[ARPlayerRealm][ARPlayerName].Auto_Tea) then
		ARCheckBoxAuto_TEA:SetChecked(1);
	else
		ARCheckBoxAuto_TEA:SetChecked(0);
	end

    if (ARData[ARPlayerRealm][ARPlayerName].Auto_Hemo) then
		ARCheckBoxAuto_HEMO:SetChecked(1);
	else
		ARCheckBoxAuto_HEMO:SetChecked(0);
	end
	
	autoRogue_CheckTrinkets()

	autoRogue.enabled = ARData[ARPlayerRealm][ARPlayerName].AutoRogueEnabled
	autoRogue.SnDpt = ARData[ARPlayerRealm][ARPlayerName].SnDpt
	SliderSnDpt:SetValue(autoRogue.SnDpt);

	autoRogue.Finisher = ARData[ARPlayerRealm][ARPlayerName].Finisher
	UIDropDownMenu_SetSelectedValue(autoRogue_DropDownButton, autoRogue.Finisher);

	autoRogue.SnDDump = ARData[ARPlayerRealm][ARPlayerName].SnDDump
	UIDropDownMenu_SetSelectedValue(autoRogue_DropDownButton2, autoRogue.SnDDump);

end

function ARSetFinisher()
	ARData[ARPlayerRealm][ARPlayerName].Finisher = autoRogue.Finisher
end

autoRogue_Finishers = {
	[1] = "Eviscerate",
	[2] = "Slice and Dice",
	[3] = "Rupture",
	[4] = "Expose Armor",
	[5] = "Kidney Shot",
};

function autoRogue_DropDownButton_OnLoad()
	UIDropDownMenu_Initialize(this, autoRogue_DropDownButton_Initialize);
	UIDropDownMenu_SetSelectedValue(this, autoRogue.Finisher);
	UIDropDownMenu_SetWidth(100, autoRogue_FinishersDropDown);
end

function autoRogue_DropDownButton_OnClick()
	--UIDropDownMenu_SetSelectedValue(autoRogue_DropDownButton, this.value);
	UIDropDownMenu_SetSelectedValue(autoRogue_DropDownButton, this.value);
	autoRogue.Finisher = this.value
	ARSetFinisher()
end

function autoRogue_DropDownButton_Initialize()
	local selectedValue = UIDropDownMenu_GetSelectedValue(autoRogue_DropDownButton);
	local info;

	info = {};
	info.text = autoRogue_Finishers[1];
	info.func = autoRogue_DropDownButton_OnClick;
	info.value = "Eviscerate";
	if ( info.value == selectedValue ) then
		info.checked = 1;
	end
	info.tooltipTitle = autoRogue_EVISCERATE;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = autoRogue_Finishers[2];
	info.func = autoRogue_DropDownButton_OnClick;
	info.value = "Slice and Dice";
	if ( info.value == selectedValue ) then
		info.checked = 1;
	end
	info.tooltipTitle = autoRogue_SLICE;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = autoRogue_Finishers[3];
	info.func = autoRogue_DropDownButton_OnClick;
	info.value = "Rupture";
	if ( info.value == selectedValue ) then
		info.checked = 1;
	end
	info.tooltipTitle = autoRogue_RUPTURE;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = autoRogue_Finishers[4];
	info.func = autoRogue_DropDownButton_OnClick;
	info.value = "Expose Armor";
	if ( info.value == selectedValue ) then
		info.checked = 1;
	end
	info.tooltipTitle = autoRogue_EXPOSE;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = autoRogue_Finishers[5];
	info.func = autoRogue_DropDownButton_OnClick;
	info.value = "Kidney Shot";
	if ( info.value == selectedValue ) then
		info.checked = 1;
	end
	info.tooltipTitle = autoRogue_KIDNEYSHOT;
	UIDropDownMenu_AddButton(info);
end
function ARSetSnDDump()
	ARData[ARPlayerRealm][ARPlayerName].SnDDump = autoRogue.SnDDump
end

autoRogue_SnDDump = {
	[1] = "Eviscerate",
	[2] = "Slice and Dice",
	[3] = "Rupture",
	[4] = "Expose Armor",
	[5] = "Kidney Shot",
};

function autoRogue_DropDownButton2_OnLoad()
	UIDropDownMenu_Initialize(this, autoRogue_DropDownButton2_Initialize);
	UIDropDownMenu_SetSelectedValue(this, autoRogue.SnDDump);
	UIDropDownMenu_SetWidth(100, autoRogue_SnDDumpDropDown);
end

function autoRogue_DropDownButton2_OnClick()
	--UIDropDownMenu_SetSelectedValue(autoRogue_DropDownButton, this.value);
	UIDropDownMenu_SetSelectedValue(autoRogue_DropDownButton2, this.value);
	autoRogue.SnDDump = this.value
	ARSetSnDDump()
end

function autoRogue_DropDownButton2_Initialize()
	local selectedValue = UIDropDownMenu_GetSelectedValue(autoRogue_DropDownButton2);
	local info;

	info = {};
	info.text = autoRogue_SnDDump[1];
	info.func = autoRogue_DropDownButton2_OnClick;
	info.value = "Eviscerate";
	if ( info.value == selectedValue ) then
		info.checked = 1;
	end
	info.tooltipTitle = autoRogue_EVISCERATE;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = autoRogue_SnDDump[3];
	info.func = autoRogue_DropDownButton2_OnClick;
	info.value = "Rupture";
	if ( info.value == selectedValue ) then
		info.checked = 1;
	end
	info.tooltipTitle = autoRogue_RUPTURE;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = autoRogue_SnDDump[4];
	info.func = autoRogue_DropDownButton2_OnClick;
	info.value = "Expose Armor";
	if ( info.value == selectedValue ) then
		info.checked = 1;
	end
	info.tooltipTitle = autoRogue_EXPOSE;
	UIDropDownMenu_AddButton(info);

	info = {};
	info.text = autoRogue_SnDDump[5];
	info.func = autoRogue_DropDownButton2_OnClick;
	info.value = "Kidney Shot";
	if ( info.value == selectedValue ) then
		info.checked = 1;
	end
	info.tooltipTitle = autoRogue_KIDNEYSHOT;
	UIDropDownMenu_AddButton(info);
end

-- Function: 		ARCheckBoxClick()
-- Arguments:		vautoRogue_to_toggle == variable that will be toggled from either true to false
-- Returns:  		None
-- Used for: 		Populates checkboxes of options panel when it is opened
function ARCheckBoxClick(vautoRogue_to_toggle)
	if ( this:GetChecked() ) then
		vautoRogue_to_toggle = true;
	else
		vautoRogue_to_toggle = false;
	end
end

function autoRogue.OnEvent(event)
	local mob, spell;
	local AR_sppattern = autoRogue_Format2Find(SPELLCASTOTHERSTART);
	--Call ARInitialize() after variables have been loaded from SavedVariables
	if ( event == "PLAYER_ENTERING_WORLD") then
		return;
	end
	if (event == "VARIABLES_LOADED") then 
		ARInitialize();
		ARMobHP_VariablesLoaded();
	elseif(event == "UNIT_INVENTORY_CHANGED") then
        autoRogue_CheckTrinkets()
	elseif( event == "UNIT_HEALTH" ) then
		ARMobHP_Display(nil, nil);
		ARTargetHP = 10000000
		if( ARTargetData ) then
			local ARhealth = UnitHealth("target");
			if( ARhealth and ARhealth ~= 0 ) then
				local ARchange = ARTargetData.currentHealthPercent - ARhealth;
				if( ARchange ~= 0 ) then
					local ARdamage = ARTargetData.tempDamagePoints;
					local ARpersistPts = ARMobHP_Pts(ARTargetData.index);
					local ARpersistPct = ARMobHP_Pct(ARTargetData.index);
					local ARcurrentPPP = ARdamage / ARchange;
					local ARupdatedPPP;

					if( (ARpersistPct + ARchange) ~= 0 ) then
						ARupdatedPPP = (ARpersistPts + ARdamage) / (ARpersistPct + ARchange);
					else
						ARupdatedPPP = 0;
					end

					ARTargetData.currentHealthPercent = ARhealth;
					ARTargetData.tempDamagePoints = 0;

					if( ARupdatedPPP > 0 ) then
						ARMobHP_Set(ARTargetData.index, ARpersistPts + ARdamage, ARpersistPct + ARchange);
					end
				end
				if not(ARMobHP_PPP == nil) then
				ARTargetHP = (ARhealth * ARMobHP_PPP(ARTargetData.index)) + 0.5
				autoRogue.d("mob has "..string.format("%d",(ARhealth * ARMobHP_PPP(ARTargetData.index)) + 0.5).."hp")
				ARMobHP_Display(ARhealth, ARTargetData.index);
				end
			end
		end
	elseif( event == "PLAYER_TARGET_CHANGED" ) then
		local ARname = UnitName("target");
		if( ARname ) then
			if( UnitCanAttack("player", "target") and not UnitIsDead("target") ) then
			--if( UnitCanAttack("player", "target") and not UnitIsDead("target") and not UnitIsPlayer("target") ) then
				-- Attackable, alive, non-player target
				ARTargetData = { };
				ARTargetData.name = ARname;
				ARTargetData.level = UnitLevel("target");
				ARTargetData.index = ARTargetData.name..":"..ARTargetData.level;
				ARTargetData.currentHealthPercent = UnitHealth("target");
				ARTargetData.tempDamagePoints = 0;

				ARMobHP_Display(ARTargetData.currentHealthPercent, ARTargetData.index);
				-- Value of Damage per energy tick
				local autoRogue_DPT = 0;

				-- Value of last per energy tick
				local autoRogue_LastDPT = 0;

				-- Value of last per energy tick
				local autoRogue_CurrDPT = 0;
                autoRogue.canKick = false
                autoRogue.tFt[1] = nil
				return;
			end
		end

		-- Unusable target
		ARTargetData = nil;
        ARTargetHP = 10000000
		ARMobHP_Display(nil, nil);
	elseif( event == "UNIT_COMBAT" ) then
		if( ARTargetData and arg1 == "target" and arg4 and arg4 ~= 0 ) then
			if( arg2 == "HEAL" ) then
				ARTargetData.tempDamagePoints = ARTargetData.tempDamagePoints - arg4;
			else
				ARTargetData.tempDamagePoints = ARTargetData.tempDamagePoints + arg4;
			end
		end
	elseif (event == "ACTIONBAR_SLOT_CHANGED") then
      autoRogue.ScanSpellsAndBars()
    elseif ( event == "UNIT_ENERGY"  and arg1 == "player" ) then
		autoRogue.d("Engery changed for player");
		-- Process the energy change if the unit triggering the event is the player
  		autoRogue.EnergyTick()
 	elseif( event == "CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE" ) then
		for mob, spell in string.gfind(arg1,AR_sppattern) do
			if (not AutoRogue_isParty(mob)) then
				local targetname = UnitName("target");
				if (mob == targetname) then
   				autoRogue.canKick = true
   				end
			end
			return;
		end
 	elseif( event == "CHAT_MSG_SPELL_HOSTILEPLAYER_DAMAGE" ) then
		for mob, spell in string.gfind(arg1,AR_sppattern) do
			if (not AutoRogue_isParty(mob)) then
				local targetname = UnitName("target");
				if (mob == targetname) then
   				autoRogue.canKick = true
				end
			end
			return;
		end
 	elseif( event == "CHAT_MSG_SPELL_PERIODIC_HOSTILEPLAYER_BUFFS" ) then
		for mob, spell in string.gfind(arg1,AR_sppattern) do
			if (not AutoRogue_isParty(mob)) then
				local targetname = UnitName("target");
				if (mob == targetname) then
   				autoRogue.canKick = true
				end
			end
			return;
		end
 	elseif( event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_BUFF" ) then
		for mob, spell in string.gfind(arg1,AR_sppattern) do
			if (not AutoRogue_isParty(mob)) then
				local targetname = UnitName("target");
				if (mob == targetname) then
   				autoRogue.canKick = true
				end
			end
			return;
		end
 	elseif( event == "CHAT_MSG_SPELL_CREATURE_VS_CREATURE_DAMAGE" ) then
		for mob, spell in string.gfind(arg1,AR_sppattern) do
			if (not AutoRogue_isParty(mob)) then
				local targetname = UnitName("target");
				if (mob == targetname) then
   				autoRogue.canKick = true
				end
			end
			return;
		end
	end		
		-- MyAddon's Support
		if(myAddOnsFrame) then
			myAddOnsList.AutoRogue = { name = "AutoRogue",
						description = "Automates most Rogue functions incuding Eviscerate, Riposte, Cheap Shot and Sinister Strike.  Intended for Combat rogues.",
						version = autoRogue.version,
						category = MYADDONS_CATEGORY_COMBAT,
						optionsframe = "AutoRogueOptionsFrame"
					};
		end

   		--------------------
		-- support for CTMod
		--------------------
		if(CT_RegisterMod) then
			CT_RegisterMod(
				autoRogue.name,
				"Setup/Options",
				4,
				"Interface\\Icons\\Ability_Warrior_Challange",
				autoRogue.desc,
				"switch",
				"",
       			AutoRogue_Toggle
			);
		end
end

function autoRogue_CheckTrinkets()
	if not(autoRogue_GetItemName(13) == nil) then
		autoRogue.trinket1 = autoRogue_GetItemName(13)
		local _,arT1Cooldown,isT1usable=GetInventoryItemCooldown("player",13);
		if arT1Cooldown <= 0 and (isT1usable == 1) and not(autoRogue.trinket1 == "") then
			autoRogue.d(autoRogue_GetItemName(13).." is ready and usable")
		else
			autoRogue.d(autoRogue_GetItemName(13).." is not ready or usable")
		end
		if (isT1usable == 1) then
            autoRogue.d(autoRogue.trinket1.." is usable")
            AROptionsText17:SetText(autoRogue.trinket1)
		else
		    AROptionsText17:SetText(autoRogue_TRINKET1)
		end
	else
        AROptionsText17:SetText(autoRogue_TRINKET1)
	end
	if not(autoRogue_GetItemName(14) == nil) then
		autoRogue.trinket2 = autoRogue_GetItemName(14)
		local _,arT2Cooldown,isT2usable=GetInventoryItemCooldown("player",14);
		if arT2Cooldown <= 0 and (isT2usable == 1) and not(autoRogue.trinket2 == "") then
			autoRogue.d(autoRogue_GetItemName(14).." is ready and usable")
		else
			autoRogue.d(autoRogue_GetItemName(14).." is not ready or usable")
		end
		if (isT2usable == 1) then
            autoRogue.d(autoRogue.trinket2.." is usable")
        	AROptionsText18:SetText(autoRogue.trinket2)
		else
		    AROptionsText18:SetText(autoRogue_TRINKET2)
		end
	else
        AROptionsText18:SetText(autoRogue_TRINKET2)
	end
end

---------------------------------------------------------------------------------
-- Register the AutoRogue button 
---------------------------------------------------------------------------------
function AutoRogue_ButtonOnLoad()
    this:RegisterForDrag("RightButton");
	this:RegisterForClicks("LeftButtonDown");
end

function AutoRogue_ButtonEnter()
		PlaySound("UChatScrollButton");
        --AutoRogue_IconFrame:SetTexture("Interface\AddOns\AutoRogue\Images\MinimapIconOver")
        
end
function AutoRogue_ButtonLeave()
        --AutoRogue_IconFrame:SetTexture("Interface\AddOns\AutoRogue\Images\MinimapIcon")
end

-- Utilities

function AutoRogue_isParty(name)
	for i = 1, 4, 1 do
		local partyname = UnitName("party" .. i);
		if (name == partyname) then
			return 1;
		end
	end
	return nil;
end

function autoRogue_GetItemName(slot)
  local linktext = nil;

  	linktext = GetInventoryItemLink("player", slot);
  if linktext then
    local _,_,name = string.find(linktext, "^.*%[(.*)%].*$");
    return name;
  else
    return "";
  end;
end;

function autoRogue_out(text)
 DEFAULT_CHAT_FRAME:AddMessage(text)
 UIErrorsFrame:AddMessage(text, 1.0, 1.0, 0, 1, 10)
end

function autoRogue.p(msg)
   DEFAULT_CHAT_FRAME:AddMessage(msg,.8,.4,0)
end

function autoRogue.da(msg)
   if (autoRogue.debugA) then
      DEFAULT_CHAT_FRAME:AddMessage(msg,.8,.4,0)
   end
end

function autoRogue.d(msg)
   if (autoRogue.debug) then
      DEFAULT_CHAT_FRAME:AddMessage(msg,.8,.4,0)
   end
end

function autoRogue.err(msg)
      UIErrorsFrame:AddMessage(msg,.8,.4,0)
end